Index: /trunk/LMDZ.GENERIC/libf/phystd/interpolateH2Ocont.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/interpolateH2Ocont.F90	(revision 305)
+++ /trunk/LMDZ.GENERIC/libf/phystd/interpolateH2Ocont.F90	(revision 305)
@@ -0,0 +1,249 @@
+     subroutine interpolateH2Ocont(wn,temp,presS,presF,abcoef,firstcall)
+      implicit none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates the H2O continuum opacity, using a lookup table from
+!     Clough (2005)
+!
+!     Authors
+!     -------
+!     R. Wordsworth (2011)
+!     
+!==================================================================
+
+#include "datafile.h"
+
+      ! input
+      double precision wn                 ! wavenumber             (cm^-1)
+      double precision temp               ! temperature            (Kelvin)
+      double precision presS              ! self-pressure          (Pascals)
+      double precision presF              ! foreign (air) pressure (Pascals)
+
+      ! output
+      double precision abcoef             ! absorption coefficient (m^-1)
+
+      integer nS,nT
+      parameter(nS=1001)
+      parameter(nT=11)
+
+      double precision kB
+      parameter(kB=1.3806488e-23)
+
+      double precision amagatS, amagatF, abcoefS, abcoefF, Nmolec
+      double precision wn_arr(nS)
+      double precision temp_arr(nT)
+      double precision abs_arrS(nS,nT)
+      double precision abs_arrF(nS,nT)
+      double precision data_tmp(nT)
+
+      integer k
+      logical firstcall
+
+      save wn_arr, temp_arr, abs_arrS, abs_arrF
+
+      character*100 dt_file
+      integer strlen,ios
+
+      amagatS=(273.15/temp)*(presS/101325.0)
+      amagatF=(273.15/temp)*(presF/101325.0)
+
+      if(firstcall)then
+
+!     1.1 Open the ASCII files
+
+         ! nu array
+         dt_file=datafile(1:LEN_TRIM(datafile))//'/continuum_data/H2O_CONT_NU.dat'
+         open(33,file=dt_file,form='formatted',status='old',iostat=ios)
+         if (ios.ne.0) then        ! file not found
+            write(*,*) 'Error from interpolateH2O_cont.for'
+            write(*,*) 'Data file could not be found:'
+            write(*,*) dt_file
+            call abort
+         else
+            do k=1,nS
+               read(33,*) wn_arr(k)
+            enddo
+         endif
+         close(33)
+
+         ! self broadening
+         dt_file=datafile(1:LEN_TRIM(datafile))//'/continuum_data/H2O_CONT_SELF.dat'
+         open(34,file=dt_file,form='formatted',status='old',iostat=ios)
+         if (ios.ne.0) then        ! file not found
+            write(*,*) 'Error from interpolateH2O_cont.for'
+            write(*,*) 'Data file could not be found:'
+            write(*,*) dt_file
+            call abort
+         else
+            do k=1,nS
+               read(34,*) data_tmp
+               abs_arrS(k,1:nT)=data_tmp(1:nT)
+            end do
+         endif
+         close(34)
+
+         ! foreign (N2+O2+Ar) broadening
+         dt_file=datafile(1:LEN_TRIM(datafile))//'/continuum_data/H2O_CONT_FOREIGN.dat'
+         open(35,file=dt_file,form='formatted',status='old',iostat=ios)
+         if (ios.ne.0) then        ! file not found
+            write(*,*) 'Error from interpolateH2O_cont.for'
+            write(*,*) 'Data file could not be found:'
+            write(*,*) dt_file
+            call abort
+         else
+            do k=1,nS
+               read(35,*) data_tmp
+               abs_arrF(k,1:nT)=data_tmp(1:nT)
+            end do
+         endif
+         close(35)
+
+         temp_arr(1)  = 200.
+         temp_arr(2)  = 250.
+         temp_arr(3)  = 300.
+         temp_arr(4)  = 350.
+         temp_arr(5)  = 400.
+         temp_arr(6)  = 450.
+         temp_arr(7)  = 500.
+         temp_arr(8)  = 550.
+         temp_arr(9)  = 600.
+         temp_arr(10) = 650.
+         temp_arr(11) = 700.
+
+         print*,'At wavenumber ',wn,' cm^-1'
+         print*,'   temperature ',temp,' K'
+         print*,'   H2O pressure ',presS,' Pa'
+         print*,'   air pressure ',presF,' Pa'
+
+         call bilinearH2Ocont(wn_arr,temp_arr,abs_arrS,wn,temp,abcoefS)
+         print*,'the self absorption is ',abcoefS,' cm^2 molecule^-1'
+
+         call bilinearH2Ocont(wn_arr,temp_arr,abs_arrF,wn,temp,abcoefF)
+         print*,'the foreign absorption is ',abcoefF,' cm^2 molecule^-1'
+
+         print*,'We have ',amagatS,' amagats of H2O vapour'
+         print*,'and ',amagatF,' amagats of air'
+
+         abcoef = abcoefS*amagatS + abcoefF*amagatF ! Eq. (15) in Clough (1989)
+
+         Nmolec = (presS+presF)/(kB*temp)
+
+         print*,'Total number of molecules per m^3 is',Nmolec
+
+         abcoef = abcoef*Nmolec/(100.0**2) ! convert to m^-1
+         abcoef = abcoef*(presS/(presF+presS))     ! take H2O mixing ratio into account
+
+         print*,'So the total absorption is ',abcoef,' m^-1'
+         print*,'And optical depth / km : ',1000.0*abcoef
+
+      else
+  
+         call bilinearH2Ocont(wn_arr,temp_arr,abs_arrS,wn,temp,abcoefS)
+         call bilinearH2Ocont(wn_arr,temp_arr,abs_arrF,wn,temp,abcoefF)
+
+         abcoef = abcoefS*amagatS + abcoefF*amagatF ! Eq. (15) in Clough (1989)
+
+         !abcoef = (presS/100000.0)*3.0e-24
+         !print*,'Matsui TEST'
+
+         Nmolec = (presS+presF)/(kB*temp)  ! sure this is correct??
+         abcoef = abcoef*Nmolec/(100.0**2) ! convert to m^-1
+         abcoef = abcoef*(presS/(presF+presS))     ! take H2O mixing ratio into account
+
+         ! unlike for Rayleigh scattering, we do not currently weight by the BB function
+         ! however our bands are normally thin, so this is no big deal.
+
+
+      endif
+
+      return
+    end subroutine interpolateH2Ocont
+
+
+
+
+!-------------------------------------------------------------------------
+      subroutine bilinearH2Ocont(x_arr,y_arr,f2d_arr,x_in,y_in,f)
+!     Necessary for interpolation of continuum data
+
+      implicit none
+
+      integer nX,nY,i,j,a,b
+      parameter(nX=1001)
+      parameter(nY=11)
+
+      real*8 x_in,y_in,x,y,x1,x2,y1,y2
+      real*8 f,f11,f12,f21,f22,fA,fB
+      real*8 x_arr(nX)
+      real*8 y_arr(nY)
+      real*8 f2d_arr(nX,nY)
+      
+      integer strlen
+      character*100 label
+      label='subroutine bilinear'
+
+      x=x_in
+      y=y_in
+
+!     1st check we're within the wavenumber range
+      if ((x.lt.x_arr(2)).or.(x.gt.x_arr(nX-2))) then
+         f=0.0D+0
+         return
+      else
+         
+!     in the x (wavenumber) direction 1st
+         i=1
+ 10      if (i.lt.(nX+1)) then
+            if (x_arr(i).gt.x) then
+               x1=x_arr(i-1)
+               x2=x_arr(i)
+               a=i-1
+               i=9999
+            endif
+            i=i+1
+            goto 10
+         endif
+      endif
+      
+      if ((y.lt.y_arr(1)).or.(y.gt.y_arr(nY))) then
+         write(*,*) 'Warning from bilinear.for:'
+         write(*,*) 'Outside continuum temperature range!'
+         if(y.lt.y_arr(1))then
+            y=y_arr(1)+0.01
+         endif
+         if(y.gt.y_arr(nY))then
+            y=y_arr(nY)-0.01
+         endif
+      else
+
+!     in the y (temperature) direction 2nd
+         j=1
+ 20      if (j.lt.(nY+1)) then
+            if (y_arr(j).gt.y) then
+               y1=y_arr(j-1)
+               y2=y_arr(j)
+               b=j-1
+               j=9999
+            endif
+            j=j+1
+            goto 20
+         endif
+      endif
+      
+      f11=f2d_arr(a,b)
+      f21=f2d_arr(a+1,b)
+      f12=f2d_arr(a,b+1)
+      f22=f2d_arr(a+1,b+1)
+      
+!     1st in x-direction
+      fA=f11*(x2-x)/(x2-x1)+f21*(x-x1)/(x2-x1)
+      fB=f12*(x2-x)/(x2-x1)+f22*(x-x1)/(x2-x1)
+      
+!     then in y-direction
+      f=fA*(y2-y)/(y2-y1)+fB*(y-y1)/(y2-y1)
+
+      return
+    end subroutine bilinearH2Ocont
Index: /trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90	(revision 305)
+++ /trunk/LMDZ.GENERIC/libf/phystd/kcm1d.F90	(revision 305)
@@ -0,0 +1,321 @@
+program kcm1d
+
+  use radinc_h,      only: NAERKIND
+  use radcommon_h,   only: L_NSPECTI, L_NSPECTV, sigma
+  use watercommon_h, only: mH2O
+  use ioipsl_getincom 
+
+  implicit none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Run the universal model radiative transfer once in a 1D column.
+!     Useful for climate evolution studies etc.
+!     
+!     It can be compiled with a command like (e.g. for 25 layers):
+!                                  "makegcm -p std -d 25 kcm1d"
+!     It requires the files "callphys.def", "gases.def"
+!     "traceur.def", and "run.def" with a line "INCLUDEDEF=callphys.def"
+!
+!     Authors
+!     -------
+!     R. Wordsworth
+!
+!==================================================================
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "callkeys.h"
+#include "comcstfi.h"
+#include "planete.h"
+#include "comsaison.h"
+#include "control.h"
+#include "advtrac.h"
+
+! --------------------------------------------------------------
+!  Declarations
+! --------------------------------------------------------------
+
+  integer nlayer,nlevel,nq
+  integer ilay,ilev,iq,iw,iter
+  real play(nlayermx)     ! Pressure at the middle of the layers [Pa]
+  real zlay(nlayermx)     ! Altitude at middle of the layers [km]
+  real plev(nlayermx+1)   ! Intermediate pressure levels [Pa]
+  real temp(nlayermx)     ! temperature at the middle of the layers [K]
+  real q(nlayermx,nqmx)   ! tracer mixing ratio [kg/kg]
+  real vmr(nlayermx,nqmx) ! tracer mixing ratio [mol/mol]
+  real qsurf(nqmx)        ! tracer surface budget [kg/kg] ????
+  real psurf,psurf_n,tsurf      
+
+  real emis, albedo
+
+  real cpp3D(nlayermx)   ! specific heat capacity at const. pressure
+  real rcp3D(nlayermx)   ! R / specific heat capacity
+  real muvar(nlayermx+1)
+
+  real dtsw(nlayermx) ! heating rate (K/s) due to SW
+  real dtlw(nlayermx) ! heating rate (K/s) due to LW
+  real fluxsurf_lw   ! incident LW flux to surf (W/m2)
+  real fluxtop_lw    ! outgoing LW flux to space (W/m2)
+  real fluxsurf_sw   ! incident SW flux to surf (W/m2)
+  real fluxabs_sw    ! SW flux absorbed by planet (W/m2)
+  real fluxtop_dn    ! incident top of atmosphere SW flux (W/m2)
+      
+! not used
+  real reffrad(nlayermx,naerkind)
+  real nueffrad(nlayermx,naerkind)
+  real cloudfrac(nlayermx)
+  real totcloudfrac
+  real tau_col
+
+  real dTstrat
+  real aerosol(nlayermx,naerkind) ! aerosol tau (kg/kg)
+  real OLR_nu(L_NSPECTI)
+  real GSR_nu(L_NSPECTV)
+  real Eatmtot
+
+  integer ierr
+  logical firstcall,lastcall
+
+! --------------
+! Initialisation
+! --------------
+
+  pi=2.E+0*asin(1.E+0)
+
+  reffrad(:,:)  = 0.0
+  nueffrad(:,:) = 0.0
+  cloudfrac(:)  = 0.0
+  totcloudfrac  = 0.0
+
+!  Load parameters from "run.def" 
+! -------------------------------
+
+! check if 'run1d.def' file is around (otherwise reading parameters
+! from callphys.def via getin() routine won't work.)
+  open(90,file='run.def',status='old',form='formatted',&
+       iostat=ierr)
+  if (ierr.ne.0) then
+     write(*,*) 'Cannot find required file "run.def"'
+     write(*,*) '  (which should contain some input parameters'
+     write(*,*) '   along with the following line:'
+     write(*,*) '   INCLUDEDEF=callphys.def'
+     write(*,*) '   )'
+     write(*,*) ' ... might as well stop here ...'
+     stop
+  else
+     close(90)
+  endif
+
+  nlayer=nlayermx
+  nlevel=nlayer+1
+
+  psurf_n=100000. ! default value for psurf
+  print*,'Dry surface pressure (Pa)?'
+  call getin("psurf",psurf_n)
+  write(*,*) " psurf = ",psurf_n
+      
+  tsurf=300.0 ! default value for tsurf
+  print*,'Surface temperature (K)?'
+  call getin("tref",tsurf)
+  write(*,*) " tsurf = ",tsurf
+
+  g=10.0 ! default value for g
+  print*,'Gravity ?'
+  call getin("g",g)
+  write(*,*) " g = ",g
+  
+  periastr = 1.0
+  apoastr  = 1.0
+  print*,'Periastron (AU)?'
+  call getin("periastr",periastr)
+  write(*,*) "periastron = ",periastr
+  dist_star = periastr 
+  fract     = 0.5
+  print*,'Apoastron (AU)?'
+  call getin("apoastr",apoastr)
+  write(*,*) "apoastron = ",apoastr
+ 
+  periastr = periastr*149.598 ! AU to Mkm
+  apoastr  = apoastr*149.598  ! AU to Mk
+
+  albedo=0.2 ! default value for albedo
+  print*,'Albedo of bare ground?'
+  call getin("albedo",albedo)
+  write(*,*) " albedo = ",albedo
+
+  emis=1.0 ! default value for emissivity
+  PRINT *,'Emissivity of bare ground ?'
+  call getin("emis",emis)
+  write(*,*) " emis = ",emis
+
+  pceil=100.0 ! Pascals
+  PRINT *,'Ceiling pressure (Pa) ?'
+  call getin("pceil",pceil)
+  write(*,*) " pceil = ", pceil
+
+  mugaz=0.
+  cpp=0.
+
+  call su_gases
+  call calc_cpp_mugaz
+
+  call inifis(1,llm,0,86400.0,1.0,0.0,0.0,1.0,rad,g,r,cpp)
+
+! Tracer initialisation
+! ---------------------
+  if (tracer) then
+     ! load tracer names from file 'traceur.def'
+     open(90,file='traceur.def',status='old',form='formatted',&
+          iostat=ierr)
+     if (ierr.eq.0) then
+        write(*,*) "kcm1d: Reading file traceur.def"
+        ! read number of tracers:
+        read(90,*,iostat=ierr) nq
+        if (ierr.ne.0) then
+           write(*,*) "kcm1d: error reading number of tracers"
+           write(*,*) "   (first line of traceur.def) "
+           stop
+        else
+           ! check that the number of tracers is indeed nqmx
+           if (nq.ne.nqmx) then
+              write(*,*) "kcm1d: error, wrong number of tracers:"
+              write(*,*) "nq=",nq," whereas nqmx=",nqmx
+              stop
+           endif
+        endif
+        
+        do iq=1,nq
+           ! minimal version, just read in the tracer names, 1 per line
+           read(90,*,iostat=ierr) tnom(iq)
+           if (ierr.ne.0) then
+              write(*,*) 'rcm1d: error reading tracer names...'
+              stop
+           endif
+        enddo !of do iq=1,nq
+     endif
+  endif
+  
+  call initracer()
+
+  do iq=1,nqmx
+     do ilay=1,nlayer
+        q(ilay,iq) = 0.
+     enddo
+  enddo
+  
+  do iq=1,nqmx
+     qsurf(iq) = 0.
+  enddo
+
+  firstcall = .true.
+  lastcall  = .false.
+
+  iter    = 1
+  Tstrat  = 200.0
+  dTstrat = 1000.0
+
+! ---------
+! Run model
+! ---------
+  do
+     psurf = psurf_n
+
+!    Create vertical profiles
+     call kcmprof_fn(psurf,qsurf(1),tsurf,    &
+          tstrat,play,plev,zlay,temp,q(:,1),muvar(1))
+
+
+     !if(1.eq.2)then
+
+!    Run radiative transfer
+     call callcorrk(ngridmx,nlayer,q,nqmx,qsurf,      &
+          albedo,emis,mu0,plev,play,temp,                    &
+          tsurf,fract,dist_star,aerosol,cpp3D,muvar,         &
+          dtlw,dtsw,fluxsurf_lw,fluxsurf_sw,fluxtop_lw,    &
+          fluxabs_sw,fluxtop_dn,reffrad,tau_col,  &
+          cloudfrac,totcloudfrac,.false.,firstcall,lastcall)
+ 
+!    Iterate stratospheric temperature
+     print*,'Tstrat = ',Tstrat
+     dTstrat = Tstrat
+     Tstrat  = (fluxabs_sw/(2*sigma))**0.25 ! skin temperature (gray approx.)
+     dTstrat = dTstrat-Tstrat
+
+     !endif
+
+     !dTstrat = 0
+
+     if(abs(dTstrat).lt.1.0)then
+        print*,'dTstrat = ',dTstrat
+        exit
+     endif
+
+     iter=iter+1
+     if(iter.eq.100)then
+        print*,'Stratosphere failed to converge after'
+        print*,'100 iteration, aborting run.'
+        call abort
+     endif
+
+  end do
+
+! Calculate total atmospheric energy
+  call calcenergy_kcm(tsurf,temp,play,plev,qsurf,&
+     q(:,1),muvar,Eatmtot)
+
+! ------------------------
+! Save data to ascii files
+! ------------------------
+
+  print*,'Saving profiles...'
+  open(115,file='profpres.out',form='formatted')
+  open(116,file='proftemp.out',form='formatted')
+  open(117,file='profztab.out',form='formatted')
+  open(118,file='profqvar.out',form='formatted')
+  open(119,file='profvvar.out',form='formatted')
+
+  write(115,*) psurf
+  write(116,*) tsurf
+  write(117,*) 0.0
+  write(118,*) qsurf(1)
+  write(119,*) qsurf(1)*(muvar(1)/mH2O)
+  do ilay=1,nlayer
+     vmr(ilay,1) = q(ilay,1)*(muvar(ilay+1)/mH2O)
+     write(115,*) play(ilay)
+     write(116,*) temp(ilay)
+     write(117,*) zlay(ilay)
+     write(118,*) q(ilay,1)
+     write(119,*) vmr(ilay,1)
+  enddo
+  close(115)
+  close(116)
+  close(117)
+  close(118)
+  close(119)
+
+  print*,'Saving scalars...'
+  open(116,file='surf_vals.out')
+  write(116,*) tsurf,psurf,fluxtop_dn,         &
+       fluxabs_sw,fluxtop_lw 
+  close(116)
+  open(111,file='ene_vals.out')
+  write(111,*) tsurf,psurf,Eatmtot,Tstrat
+  close(111)
+
+  print*,'Saving spectra...'
+  open(117,file='OLRnu.out')
+  do iw=1,L_NSPECTI
+     write(117,*) OLR_nu(iw)
+  enddo
+  close(117)
+  
+  open(127,file='GSRnu.out')
+  do iw=1,L_NSPECTV
+     write(127,*) GSR_nu(iw)
+  enddo
+  close(127)  
+
+end program kcm1d
Index: /trunk/LMDZ.GENERIC/libf/phystd/kcmprof_fn.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/kcmprof_fn.F90	(revision 305)
+++ /trunk/LMDZ.GENERIC/libf/phystd/kcmprof_fn.F90	(revision 305)
@@ -0,0 +1,363 @@
+subroutine kcmprof_fn(psurf_rcm,qsurf_rcm,Tsurf_rcm,Tstra_rcm,P_rcm,Pl_rcm,z_rcm,T_rcm,q_rcm,m_rcm)
+
+use params_h
+use watercommon_h, only : mH2O
+implicit none
+
+!     ----------------------------------------------------------------
+!     Purpose: create profiles of T, rho_v, rho_n, Pv and Pn following 
+!              Kasting 1988
+!     Authour: Adapted from a code by E. Marcq by R. Wordsworth (2011)
+!     ----------------------------------------------------------------
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+#include "callkeys.h"
+#include "gases.h"
+
+  integer ilay, nlay
+  parameter (nlay=10000) ! number of vertical layers
+
+  ! rcm inputs
+  real Tsurf_rcm,Tstra_rcm
+
+  ! rcm outputs
+  real psurf_rcm,qsurf_rcm
+  real P_rcm(1:nlayermx)
+  real Pl_rcm(1:nlayermx+1)
+  real z_rcm(1:nlayermx)
+  real T_rcm(1:nlayermx),q_rcm(1:nlayermx)
+  real m_rcm(1:nlayermx+1)
+
+  ! rcm for interpolation (should really use log coords?)
+  !double precision p1,p2,pnew,ilay_rcm
+
+  double precision lnp1,lnp2,lnpnew
+  real Dp_rcm, dlogp_rcm
+  integer ilay_rcm,ilev_rcm,ifinal_rcm
+
+  double precision Dz, Dp
+  double precision Ptop, dlogp, Psat_max
+  parameter (Ptop=1.0)           ! Pressure at TOA [Pa]
+  parameter (Psat_max=5000.0) ! Maximum vapour pressure [Pa]
+
+  double precision T(1:nlay)                       ! temperature [K]
+  double precision Ztab(1:nlay)                    ! altitude [m]
+  double precision Pv(1:nlay),Pn(1:nlay),P(1:nlay) ! pressure [Pa]
+  double precision rho_v(1:nlay), rho_n(1:nlay)    ! density [kg m^-3]
+  double precision a_v(1:nlay)                     ! = rho_v/rho_n [kg/kg]
+  double precision q_v(1:nlay)                     ! = rho_v/rho_tot [kg/kg]
+  double precision mtot(1:nlay)                    ! = (rho_v+rho_n)/(n_v+n_n) [g/mol]
+
+  integer profil_flag(1:nlay) ! 0 = dry, 1 = moist, 2 = isothermal
+
+  ! inputs
+  double precision Tsurf   ! surface temperature [K]
+  double precision Psurf_v ! surface par. pressure (variable species) [Pa]
+  double precision Psurf_n ! surface par. pressure (incondensible species)[Pa]
+  double precision Ttop    ! stratospheric temperature [K]
+
+  double precision dTdp        ! [K/Pa]
+  double precision dPvdp,dPndp ! [Pa/Pa]
+  double precision psat_v      ! local Psat_H2O value
+  double precision Tcrit       ! Critical temperature [K]
+!  double precision Tsat        ! local Tsat_H2O value
+  double precision rho_vTEMP,rho_nTEMP
+
+  ! variables necessary for steam.f90
+  double precision rhol,rhov,nul
+
+  ! for output
+  double precision vmr
+
+  logical verbose
+  parameter(verbose=.false.)
+
+  ! initialise flags
+  profil_flag(:) = 0
+
+  !-------------------------------
+  ! assign input variables
+  m_n     = dble(mugaz/1000.)
+  ! modify/generalise later??
+
+  if(gnom(2).eq.'H2O')then
+     m_v   = dble(mH2O/1000.)
+     tcrit = 6.47d2
+  elseif(gnom(2).eq.'NH3')then
+     m_v   = 17.031/1000.
+     tcrit = 4.06d2
+  elseif(gnom(2).eq.'CH4')then
+     m_v   = 16.04/1000.
+     tcrit = 1.91d2
+     stop
+  else
+     print*,'Variable gas not recognised!'
+     call abort
+  endif
+
+  rmn     = rc/m_n
+  
+  Psurf_n = dble(psurf_rcm)
+  Ttop    = dble(Tstra_rcm)
+  Tsurf   = dble(Tsurf_rcm)
+
+
+  ! assume vapour saturation at surface (for now)
+!  if (tsurf > tcrit) then
+!     print*,'Above critical temperature for ',gnom(2),&
+!          ', at surface, assuming 10 bar pressure instead'
+!     Psurf_v = 10*1d5
+!     profil_flag(1) = 0
+!i!  endif
+
+  if(gnom(2).eq.'H2O')then
+     call Psat_H2O(tsurf,psat_v)
+  elseif(gnom(2).eq.'NH3')then
+     call Psat_NH3(tsurf,psat_v)
+  endif
+
+  ! Moist adiabat unless greater than psat_max
+  if(psat_v*1d6.lt.psat_max)then
+    Psurf_v = Psat_v*1d6
+    profil_flag(1) = 1
+  else 
+    Psurf_v = psat_max
+    profil_flag(1) = 0
+  endif
+
+
+
+  if(verbose)then
+     print*,'Psat_v  =',psat_v*1d6
+     print*,'Tsurf   =',Tsurf,' K'
+     print*,'Ttop    =',Ttop,' K'
+     print*,'Psurf_v =',Psurf_v,' Pa'
+     print*,'Psurf_n =',Psurf_n,' Pa'
+     print*,'m_n     =',m_n,' kg/mol'
+     print*,'m_v     =',m_v,' kg/mol'
+     print*,'rc      =',rc
+  endif
+
+  ! define fine pressure grid
+  psurf_rcm = real(Psurf_n+Psurf_v)
+  dlogp_rcm = -(log(psurf_rcm)-log(ptop))/nlayermx
+
+  P_rcm(1)  = psurf_rcm*exp(dlogp_rcm)
+  do ilay_rcm=1,nlayermx-1
+     P_rcm(ilay_rcm+1) = P_rcm(ilay_rcm)*exp(dlogp_rcm)
+  enddo
+
+  Pl_rcm(1) = psurf_rcm
+  do ilev_rcm=2,nlayermx
+     ! log-linear interpolation
+     Pl_rcm(ilev_rcm) = exp( log( P_rcm(ilev_rcm)*P_rcm(ilev_rcm-1) )/2 )
+  enddo
+
+  !-------------------------------
+  ! Layer 1
+  T(1)     = Tsurf
+  Pv(1)    = Psurf_v
+  Pn(1)    = Psurf_n
+  rho_n(1) = m_n*Pn(1)/(Rc*Tsurf)
+  rho_v(1) = m_v*Pv(1)/(Rc*Tsurf)
+  a_v(1)   = rho_v(1)/rho_n(1)
+
+  ! log pressure grid spacing (constant)
+  dlogp = -(log(Pn(1)+Pv(1))-log(ptop))/(nlay-1)
+
+  call gradients_kcm(profil_flag(1),rho_v(1),rho_n(1),Tsurf,dTdp,dPvdp,dPndp)
+  if(verbose)then
+     print*, 'dT/dp ground [K/Pa] =',dTdp
+  endif
+
+  ! initial delta p, delta z
+  Dp = (Pn(1) + Pv(1))*(exp(dlogp) - 1d0)
+  Dz = -Dp/(  g*(rho_n(1) + rho_v(1))  )
+
+  !-------------------------------
+  ! Layer 2
+  T(2)     = tsurf + dTdp*Dp 
+  Pv(2)    = Pv(1) + dPvdp*Dp
+  Pn(2)    = Pn(1) + dPndp*Dp
+  rho_n(2) = m_n*Pn(2)/(Rc*T(2))
+  rho_v(2) = m_v*Pv(2)/(Rc*T(2))
+  a_v(2)   = rho_v(2)/rho_n(2)
+
+  !-------------------------------
+  ! start vertical ascent
+  Ztab(1) = 0.
+  do ilay=2,nlay-1
+
+
+
+
+     ! calculate altitude levels (for diagnostic only)
+     Dz         = -Dp/(  g*(rho_n(ilay) + rho_v(ilay))  )
+     Ztab(ilay) = Dz + Ztab(ilay-1)
+
+     ! 1st assume next layer same as last one
+     profil_flag(ilay) = profil_flag(ilay-1)
+  
+     ! update delta p
+     Dp = (Pn(ilay)+Pv(ilay))*(exp(dlogp) - 1d0)
+
+     ! intial gradients call to calculate temperature at next level
+     call gradients_kcm(profil_flag(ilay),rho_v(ilay),rho_n(ilay),&
+                        T(ilay),dTdp,dPvdp,dPndp)
+
+     T(ilay+1) = T(ilay) + dTdp*Dp
+
+     ! test for moist adiabat at next level
+     if(gnom(2).eq.'H2O')then
+        call Psat_H2O(T(ilay+1),psat_v)
+     elseif(gnom(2).eq.'NH3')then
+        call Psat_NH3(T(ilay+1),psat_v)
+     endif
+
+     if (psat_v*1d6 .lt. Pv(ilay)+dPvdp*Dp) then
+        profil_flag(ilay)=1
+        call gradients_kcm(profil_flag(ilay),rho_v(ilay),rho_n(ilay),&
+                         T(ilay),dTdp,dPvdp,dPndp)
+     endif
+
+     ! test for stratosphere at next level
+     if (T(ilay+1) .le. Ttop) then
+        profil_flag(ilay)=2
+        T(ilay+1)=Ttop
+     endif
+
+     ! calculate pressures at next level
+     Pn(ilay+1) = Pn(ilay) + dPndp*Dp
+     Pv(ilay+1) = Pv(ilay) + dPvdp*Dp
+
+     if(profil_flag(ilay) .eq. 1)then
+        
+        if(gnom(2).eq.'H2O')then
+           call Psat_H2O(T(ilay+1),psat_v)
+        elseif(gnom(2).eq.'NH3')then
+           call Psat_NH3(T(ilay+1),psat_v)
+        endif
+
+        if(Pv(ilay+1) .lt. psat_v*1e6)then
+           Pv(ilay+1)=psat_v*1d6
+        endif
+
+     endif
+
+     ! calculate gas densities at next level (assume ideal)
+     rho_n(ilay+1) = m_n*Pn(ilay+1)/(rc*T(ilay+1)) 
+     select case(profil_flag(ilay)) 
+     case(2) ! isothermal
+        rho_v(ilay+1) = rho_v(ilay)/rho_n(ilay)*rho_n(ilay+1)
+     case(1) ! moist
+
+        ! dont think this is necessary
+        !call psat_est(T(ilay+1),psat_v)
+        ! modify for ammonia!!!
+
+        rho_v(ilay+1) = m_v*psat_v*1d6/(rc*T(ilay+1))
+     case(0) ! dry
+        rho_v(ilay+1) = m_v*Pv(ilay+1)/(rc*T(ilay+1)) 
+     end select
+
+
+
+!         print*,'profil_flag=',profil_flag(ilay)
+!         print*,'T=',T(ilay)
+!         print*,'a=',rho_v(ilay)/rho_n(ilay)
+!      if(profil_flag(ilay).eq.1)then
+!           stop
+!     endif
+
+
+
+
+
+  enddo
+
+  Ztab(nlay)=Ztab(nlay-1)+Dz
+
+  !-------------------------------
+  ! save to kcm1d variables 
+
+  ! surface quantities
+  psurf_rcm = Pn(1) + Pv(1)
+  qsurf_rcm = rho_v(1)/(rho_v(1) + rho_n(1))
+
+  ! create q_v, mtot for saving
+  do ilay=1,nlay
+     mtot(ilay) = 1d3*(rho_v(ilay) + rho_n(ilay)) / &
+                  (rho_v(ilay)/m_v + rho_n(ilay)/m_n)
+     q_v(ilay)  = rho_v(ilay)/(rho_v(ilay) + rho_n(ilay))
+     ! CHECK THIS
+  enddo
+
+
+  ! convert to rcm lower-res grid
+  z_rcm(:) = 0.0
+  T_rcm(:) = 0.0
+  q_rcm(:) = 0.0
+  m_rcm(:) = 0.0
+
+  m_rcm(1) = real( 1d3*(rho_v(1) + rho_n(1)) / &
+                  (rho_v(1)/m_v + rho_n(1)/m_n) )
+
+  ilay_rcm=1
+  do ilay=2,nlay
+
+     if(ilay_rcm.le.nlayermx)then
+     ! interpolate rcm variables
+
+        if(Pn(ilay)+Pv(ilay) .lt. P_rcm(ilay_rcm))then
+
+           if(ilay.eq.1)then
+              print*,'Error in create_profils: Psurf here less than Psurf in RCM!'
+              call abort
+           endif
+
+           lnp1   = log(Pn(ilay-1)+Pv(ilay-1))
+           lnp2   = log(Pn(ilay)+Pv(ilay))
+           lnpnew = dble(log(P_rcm(ilay_rcm)))
+
+           z_rcm(ilay_rcm) = real(Ztab(ilay-1)*(lnp2-lnpnew)/(lnp2-lnp1) &
+                             + Ztab(ilay)*(lnpnew-lnp1)/(lnp2-lnp1))
+           T_rcm(ilay_rcm) = real(T(ilay-1)*(lnp2-lnpnew)/(lnp2-lnp1) &
+                             + T(ilay)*(lnpnew-lnp1)/(lnp2-lnp1))
+           q_rcm(ilay_rcm) = real(q_v(ilay-1)*(lnp2-lnpnew)/(lnp2-lnp1) &
+                             + q_v(ilay)*(lnpnew-lnp1)/(lnp2-lnp1))
+
+           m_rcm(ilay_rcm+1) = real(mtot(ilay-1)*(lnp2-lnpnew)/(lnp2-lnp1) &
+                             + mtot(ilay)*(lnpnew-lnp1)/(lnp2-lnp1))
+
+           ilay_rcm = ilay_rcm+1
+        endif
+
+     endif
+  enddo
+
+  ifinal_rcm=ilay_rcm-1
+  if(ifinal_rcm.lt.nlayermx)then
+     if(verbose)then
+        print*,'Interpolation in kcmprof stopped at layer',ilay_rcm,'!'
+     endif
+
+     do ilay_rcm=ifinal_rcm+1,nlayermx
+
+        z_rcm(ilay_rcm) = z_rcm(ilay_rcm-1)
+        T_rcm(ilay_rcm) = T_rcm(ilay_rcm-1)
+        q_rcm(ilay_rcm) = q_rcm(ilay_rcm-1)
+        m_rcm(ilay_rcm+1) = m_rcm(ilay_rcm)
+
+     enddo
+  endif
+
+  do ilay=2,nlayermx
+     if(T_rcm(ilay).lt.Ttop)then
+        T_rcm(ilay)=Ttop
+     endif
+  enddo
+
+  return
+end subroutine kcmprof_fn
Index: /trunk/LMDZ.GENERIC/libf/phystd/optci.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/optci.F90	(revision 304)
+++ /trunk/LMDZ.GENERIC/libf/phystd/optci.F90	(revision 305)
@@ -1,5 +1,5 @@
       subroutine optci(PLEV,TLEV,DTAUI,TAUCUMI,      &
            QXIAER,QSIAER,GIAER,COSBI,WBARI,TAUAERO,  &
-           TMID,PMID,TAUGSURF,QVAR)
+           TMID,PMID,TAUGSURF,QVAR,MUVAR)
 
       use radinc_h
@@ -59,8 +59,8 @@
       real*8 taugsurf(L_NSPECTI,L_NGAUSS-1)
       real*8 DCONT
-      double precision wn_cont, p_cont, T_cont
-
-!     Water mixing ratio variables
-      real*8  QVAR(L_LEVELS), WRATIO(L_LEVELS)
+      double precision wn_cont, p_cont, p_air, T_cont, dtemp
+
+!     Variable species mixing ratio variables
+      real*8  QVAR(L_LEVELS), WRATIO(L_LEVELS), MUVAR(L_LEVELS)
       real*8  KCOEF(4)
       integer NVAR(L_LEVELS)
@@ -97,5 +97,4 @@
       do K=2,L_LEVELS
          DPR(k) = PLEV(K)-PLEV(K-1)
-         U(k)   = Cmk*DPR(k)    ! only Cmk line in optci.F
 
          !--- Kasting's CIA ----------------------------------------
@@ -110,5 +109,11 @@
 
          ! if we have continuum opacities, we need dz
-         dz(k)=dpr(k)*R*TMID(K)/(g*PMID(K))
+         if(kastprof)then
+            dz(k) = dpr(k)*(8314.5/muvar(k))*TMID(K)/(g*PMID(K))
+            U(k)  = (Cmk*mugaz/(muvar(k)))*DPR(k) 
+         else
+            dz(k) = dpr(k)*R*TMID(K)/(g*PMID(K))
+            U(k)  = Cmk*DPR(k)    ! only Cmk line in optci.F
+         endif
 
          call tpindex(PMID(K),TMID(K),QVAR(K),pfgasref,tgasref,WREFVAR, &
@@ -132,19 +137,30 @@
             DCONT = 0.0 ! continuum absorption
 
-            ! include H2 continuum
+            ! include continua if necessary
+            wn_cont = dble(wnoi(nw))
+            T_cont  = dble(TMID(k))
             do igas=1,ngasmx
-               if(gnom(igas).eq.'H2_')then 
-
-                  wn_cont = dble(wnoi(nw))
-                  T_cont  = dble(TMID(k))
-                  p_cont  = dble(PMID(k)*scalep*gfrac(igas))
-
-                  call interpolateH2H2(wn_cont,T_cont,p_cont,DCONT,.false.)
-
-                  DCONT=DCONT*dz(k)
-
-
+
+               if(gfrac(igas).eq.-1)then ! variable
+                  p_cont  = dble(PMID(k)*scalep*QVAR(k)) ! qvar = mol/mol
+               else
+                  p_cont  = dble(PMID(k)*scalep*gfrac(igas)*(1.-QVAR(k)))
                endif
+
+               dtemp=0.0
+               if(gnom(igas).eq.'H2_')then
+                  call interpolateH2H2(wn_cont,T_cont,p_cont,dtemp,.false.)
+               elseif(gnom(igas).eq.'H2O'.and.T_cont.gt.200.0)then
+                  p_air = dble(PMID(k)*scalep) - p_cont ! note assumes air!!
+                  call interpolateH2Ocont(wn_cont,T_cont,p_cont,p_air,dtemp,.false.)
+
+               endif
+
+               DCONT = DCONT + dtemp
+
             enddo
+
+
+            DCONT = DCONT*dz(k) 
 
             !--- Kasting's CIA ----------------------------------------
@@ -154,8 +170,4 @@
             !----------------------------------------------------------
 
-            ! Water continuum currently inactive!
-            !if(varactive)then
-            !   call water_cont(PMID(K),TMID(K),WRATIO(K),WNOI(nw),DCO2)
-            !endif
 
             do ng=1,L_NGAUSS-1
@@ -197,4 +209,9 @@
                
                TAUGAS  = U(k)*ANS
+
+               if(graybody)then
+                  TAUGAS = 0.0
+                  DCONT  = U(k)*3.3e-26
+               endif
 
                TAUGSURF(NW,NG) = TAUGSURF(NW,NG) + TAUGAS + DCONT
@@ -311,27 +328,9 @@
       END DO
 
-
       return
+
+
     end subroutine optci
 
 
-!-------------------------------------------------------------------------
-    subroutine water_cont(p,T,wratio,nu,DCONT)
-!   Calculates the continuum opacity for H2O
-!   NOT CURRENTLY USED
-
-      implicit none
-
-      real p, T, wratio, nu, DCONT
-      real h1, h2
-
-      h1 = exp(1800.*(1./T - 0.0034))
-      h2 = 1.25e-22 + 1.67e-19*exp(-2.62e-13*nu)
-
-!      DCONT = h1*h2*p*(p*wratio)**2/(R*T)
-!      DCONT=0.0 ! to be implemented...
-
-      return
-
-    end subroutine water_cont
-
+
